unit SzovKer;
(*
   A Knuth-Morris-Pratt, ill. Boyer-Moore mdszernek kdolsa.
   (Ez csak a keret.)
*)

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, StdCtrls{TMemo};

  Procedure EltolasGeneralasKMP(sminta:String);
  Procedure KeresKMP(mm:TMemo; const sminta:string); {Knuth-Morris-Pratt
                                                      mdszerrel}
  Procedure EltolasGeneralasBM(sminta:String);
  Procedure KeresBM(mm:TMemo; const sminta:string); {Boyer-Moore mdszerrel}

implementation

uses
  FoAblak{fmSzovKer};
  
//Knuth-Morris-Pratt:

Procedure EltolasGeneralasKMP(sminta:String);
Begin
  //...
End;//EltolasGeneralasKMP

Procedure KeresKMP(mm:TMemo; const sminta:string); {Knuth-Morris-Pratt
                                                    mdszerrel}
Begin
  with fmSzovKer do//a folyamatos kirs rdekben
  begin
    //...
    sorbanHolKMP:={i+}1;//legkzelebb innen
    lbHasDbKMP.Caption:=DBCimke+IntToStr(hasDbKMP);
  end;//with
End;//KeresKMP

//Boyer-Moore:

Procedure EltolasGeneralasBM(sminta:String);
Begin
  //...
End;//EltolasGeneralasBM

Procedure KeresBM(mm:TMemo; const sminta:string); {Boyer-Moore mdszerrel}

  procedure Szinkronizalas(var i:integer);
  begin
    //...
  end;//Szinkronizalas

Begin
  with fmSzovKer do
  begin
    //...
    sorbanHolBM:={i+smH}+1;//legkzelebb innen
    lbHasDbBM.Caption:=DBCimke+IntToStr(hasDbBM);
  end;//with
End;//KeresBM

end.

